- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# ec2_tag – create and remove tags on ec2 resources

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Creates, removes and lists tags for any EC2 resource. The resource is referenced by its resource id (e.g. an instance being i-XXXXXXX). It is designed to be used with complex args (tags), see the examples.

## Requirements

The below requirements are needed on the host that executes this module.

- boto
- boto3
- botocore
- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
purge_tags boolean added in 2.7 | Choices: no ← yes | Whether unspecified tags should be removed from the resource. Note that when combined with `state: absent`, specified tags with non-matching values are not purged.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
resource - / required |  | The EC2 resource id.
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
state - | Choices: present ← absent list | Whether the tags should be present or absent on the resource. Use list to interrogate the tags of an instance.
tags - / required |  | A dictionary of tags to add or remove from the resource. If the value provided for a tag is null and `state` is absent, the tag will be removed regardless of its current value.
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`
- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html
- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    - name: Ensure tags are present on a resource
      ec2_tag:
        region: eu-west-1
        resource: vol-XXXXXX
        state: present
        tags:
          Name: ubervol
          env: prod

    - name: Ensure all volumes are tagged
      ec2_tag:
        region:  eu-west-1
        resource: '{{ item.id }}'
        state: present
        tags:
          Name: dbserver
          Env: production
      loop: '{{ ec2_vol.volumes }}'

    - name: Retrieve all tags on an instance
      ec2_tag:
        region: eu-west-1
        resource: i-xxxxxxxxxxxxxxxxx
        state: list
      register: ec2_tags

    - name: Remove the Env tag
      ec2_tag:
        region: eu-west-1
        resource: i-xxxxxxxxxxxxxxxxx
        tags:
          Env:
        state: absent

    - name: Remove the Env tag if it's currently 'development'
      ec2_tag:
        region: eu-west-1
        resource: i-xxxxxxxxxxxxxxxxx
        tags:
          Env: development
        state: absent

    - name: Remove all tags except for Name from an instance
      ec2_tag:
        region: eu-west-1
        resource: i-xxxxxxxxxxxxxxxxx
        tags:
            Name: ''
        state: absent
        purge_tags: true

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
added_tags dictionary | If tags were added | A dict of tags that were added to the resource
removed_tags dictionary | If tags were removed | A dict of tags that were removed from the resource
tags dictionary | always | A dict containing the tags on the resource

## Status

- This module is guaranteed to have backward compatible interface changes going forward. [stableinterface]
- This module is maintained by the Ansible Community. [community]

### Authors

- Lester Wade (@lwade)
- Paul Arthur (@flowerysong)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.